<?php

class TNG_Profile_Box extends WP_Widget {
	public function __construct() {
		parent::__construct(
	 		'tng_profile_box', // Base ID
			'TNG Profile Box', // Name
			array( 'description' => __( 'Displays an profile of a chosen TNG person.', 'tng_domain' ), ) // Args
		);
	}
	
	public function widget( $args, $instance ) {
		global $languages_path, $text, $cms, $dates, $before_widget, $after_widget, $content, $personID;
// from getperson
		global $rootpath, $photopath, $documentpath, $headstonepath, $historypath, $mediapath, $mediatypes_assoc;
		global $photosext, $tree, $medialinks_table, $media_table, $text, $cms, $admtext, $tngconfig;
// from pedigree
		global $pedigree, $generations, $pedmax, $pedoptions, $boxes, $flags, $offpageimgh, $offpageimgw, $cms, $rounded, $templatepath;
		// TNG general calls
		$tng_folder = get_option('mbtng_path');
		include( $tng_folder.'config.php' );
		include($tng_folder."subroot.php");
		// TNG widget specfic calls
		$base_url = trailingslashit($tngdomain);

			/* User-selected settings. */
			$title = apply_filters( 'widget_title', $instance['title'] );
			$tree = $instance['tree'];
			$personID = $instance['personID'];
			$description = $instance['description'];

			$content = tng_get_profile_box( $base_url, $tree, $personID, $description );

			/* Before widget (defined by themes). */
			echo $before_widget;

			/* Title of widget (before and after defined by themes). */
			if ( ! empty( $title ) )
				echo $before_title .'<h4 class="widget-title">'. $title .'</h4>'. $after_title;

			/* Display widget content from widget settings. */
			if ( $content )
				echo $content; 

			/* After widget (defined by themes). */
			echo $after_widget;
	}
	
	public function update( $new_instance, $old_instance ) {
		global $instance, $personID, $tree;
		$instance = $old_instance;
		/* Strip tags (if needed) and update the widget settings. */
		$instance['title'] = strip_tags( $new_instance['title'] );
		$instance['tree'] = strip_tags( $new_instance['tree'] );
		$instance['personID'] = strip_tags( $new_instance['personID'] );
		$instance['description'] = strip_tags( $new_instance['description'] );
		return $instance;
	}

 	public function form( $instance ) {
		global $tree, $personID;
		// outputs the options form on admin
		if ( empty( $instance[ 'title' ] ) ) {
			$instance['title'] = __( 'Individual Profile', 'text_domain' );
		}
		$title = $instance['title'];
		$tree = $instance['tree'];
		$personID = $instance['personID'];
		$description = $instance['description'];

		?>
		<p class="tng-widget-admin tng-option-title">
			<label for="<?php echo $this->get_field_id( 'title' ); ?>" class="tng-widget-label tng-title"><?php _e( 'Title:' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" class="tng-widget-input tng-title" />
		</p>
		<p class="tng-widget-admin tng-option-text">
			<label for="<?php echo $this->get_field_id( 'tree' ); ?>" class="tng-widget-label tng-tree"><?php _e( 'TNG Tree:' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'tree' ); ?>" name="<?php echo $this->get_field_name( 'tree' ); ?>" type="text" value="<?php echo esc_attr( $tree ); ?>" class="tng-widget-input tng-tree" />
		</p>
		<p class="tng-widget-admin tng-option-text">
			<label for="<?php echo $this->get_field_id( 'personID' ); ?>" class="tng-widget-label tng-personID"><?php _e( 'TNG Person ID:' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'personID' ); ?>" name="<?php echo $this->get_field_name( 'personID' ); ?>" type="text" value="<?php echo esc_attr( $personID ); ?>" class="tng-widget-input tng-personID" />
		</p>
		<p class="tng-widget-admin tng-option-textarea">
			<label for="<?php echo $this->get_field_id( 'description' ); ?>" class="tng-widget-label tng-description"><?php _e( 'TNG Description:' ); ?></label>
			<textarea id="<?php echo $this->get_field_id( 'description' ); ?>" name="<?php echo $this->get_field_name( 'description' ); ?>" class="widefat tng-widget-input"><?php echo esc_attr( $description ); ?></textarea>
		</p>
		<?php
	}
}

function tng_get_profile_box( $base_url, $tree, $personID, $description ) {
	$profilearr = tng_get_profile_data( $tree, $personID );
	$personHREF = $base_url."getperson.php?personID=".$personID."&amp;tree=".$tree;
	$namestr = $profilearr[0];
	$photostr = $profilearr[1];
	$yearsstr = $profilearr[2];

 	$profile = "<span class=\"tng-widget-content\">";
	$profile .= "<a href=\"".$personHREF."\">\n";
 	$profile .= "<h5 class=\"tng-profile-name\">" . $namestr . "</h5>";
	$profile .= "</a>\n";
 	$profile .= "<span class=\"tng-profile-photo\" style=\"margin-left:2vw;\">" . $photostr . "</span>";
 	$profile .= "<h6 class=\"tng-profile-years\">" . $yearsstr . "</h6>";
 	$profile .= "<p class=\"tng-widget-description\">" . $description . "</p>";
 	$profile .= "</span>";
 	return $profile;
}

function tng_get_profile_data( $tree, $personID ) { 
	global $people_table;
	$tng_folder = get_option('mbtng_path');
    include($tng_folder.'config.php');
	$link = mysqli_connect($database_host, $database_username, $database_password, $database_name) or die("Error: TNG is not communicating with your database. Please check your database settings and try again.");
	$query = "SELECT * FROM $people_table WHERE personID = \"$personID\" AND gedcom = \"$tree\"";
	$result = mysqli_query($link,$query) or die ("Unable to execute query: $query");

	$row=mysqli_fetch_array($result);
	
	if( !$num_rows = $result->num_rows ) {
		mysqli_free_result( $result );
		return NULL;
		exit;
	}
	else
		mysqli_free_result( $result );

    $row['allow_living'] = $rights['living'];
    $row['allow_private'] = $rights['private'];

	$namestr = $row['firstname']." ".$row['lastname'];
//	debugPrint($namestr);
	$photostr = myGetPhoto();
//	debugPrint($photostr);
	$yearsstr = $row['birthdate']." &mdash; ".$row['deathdate'];
//	debugPrint($yearsstr);

	$arr = array( $namestr, $photostr, $yearsstr );	
	return $arr;

}
function myGetPhoto() {
	global $people_table,$medialinks_table, $media_table, $tree, $personID;
	$tng_folder = get_option('mbtng_path');
	include($tng_folder.'config.php');
	$base_url = trailingslashit($tngdomain);
	$link = mysqli_connect($database_host, $database_username, $database_password, $database_name) or die("Error: TNG is not communicating with your database. Please check your database settings and try again.");
	$query = "SELECT $media_table.mediaID, medialinkID, mediakey, alwayson, thumbpath, mediatypeID, usecollfolder, newwindow FROM ($media_table, $medialinks_table)
		WHERE $medialinks_table.personID = \"$personID\" AND $medialinks_table.gedcom = \"$tree\" AND $media_table.mediaID = $medialinks_table.mediaID AND defphoto = '1'";
	$result = mysqli_query($link,$query) or die ("Unable to execute query: $query");
	$row = mysqli_fetch_array( $result );
	//$showmedia_url = $tngdomain;
	$showmedia_url = 'https://'.$_SERVER['SERVER_NAME'].'/wp-content/uploads/';
	$media=$row['mediatypeID'].'/'.$row['thumbpath'];
	$medialink=$row['medialinkID'];
	$link = "?mediaID=$media&amp;medialinkID=$medialink";
	$photo = '<img src="'.$showmedia_url.'/'.$media.'" class=\"smallimg\"/>';
	mysqli_free_result( $result );
	return $photo;
}