<?php

class TNG_Random_Profile_Box extends WP_Widget {
	public function __construct() {
		parent::__construct(
	 		'tng_random_profile_box', // Base ID
			'TNG Random Profile Box', // Name
			array( 'description' => __( 'Randomly displays a profile of an individual in the TNG Database.', 'tng_domain' ), ) // Args
		);
	}
	
	public function widget( $args, $instance ) {
		global $languages_path, $text, $cms, $dates, $before_widget, $after_widget, $content, $personID;
// from getperson
		global $rootpath, $photopath, $documentpath, $headstonepath, $historypath, $mediapath, $mediatypes_assoc;
		global $photosext, $tree, $medialinks_table, $media_table, $text, $cms, $admtext, $tngconfig;
// from pedigree
		global $pedigree, $generations, $pedmax, $pedoptions, $boxes, $flags, $offpageimgh, $offpageimgw, $cms, $rounded, $templatepath;
		// TNG general calls
		$tng_folder = get_option('mbtng_path');
		include( $tng_folder.'config.php' );
		include($tng_folder."subroot.php");
		// TNG widget specfic calls
		$base_url = trailingslashit($tngdomain);

			/* User-selected settings. */
			$title = apply_filters( 'widget_title', $instance['title'] );
			$tree = $instance['tree'];
			$personID = $instance['personID'];

			$content = tng_get_random_profile_box( $base_url, $tree, $personID );

			/* Before widget (defined by themes). */
			echo $before_widget;

			/* Title of widget (before and after defined by themes). */
			if ( ! empty( $title ) )
				echo $before_title .'<h4 class="widget-title">'. $title .'</h4>'. $after_title;

			/* Display widget content from widget settings. */
			if ( $content )
				echo $content; 

			/* After widget (defined by themes). */
			echo $after_widget;
	}
	//Auto update instance every day
	public function update( $new_instance, $old_instance ) {
		global $instance, $personID, $tree;
		$instance = $old_instance;
		/* Strip tags (if needed) and update the widget settings. */
		$instance['title'] = strip_tags( $new_instance['title'] );
		$instance['tree'] = strip_tags( $new_instance['tree'] );
		$instance['personID'] = strip_tags( $new_instance['personID'] );
		//$instance['description'] = strip_tags( $new_instance['description'] );
		return $instance;
	}

 	public function form( $instance ) {
		global $tree, $personID;
		// outputs the options form on admin for widget title and tree selection
		if ( empty( $instance[ 'title' ] ) ) {
			$instance['title'] = __( 'Featured Ancestor', 'text_domain' );
		}
		$title = $instance['title'];
		$tree = $instance['tree'];
//		$personID = $instance['personID'];
//		$description = $instance['description'];

		?>
		<p class="tng-widget-admin tng-option-title">
			<label for="<?php echo $this->get_field_id( 'title' ); ?>" class="tng-widget-label tng-title"><?php _e( 'Title:' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" class="tng-widget-input tng-title" />
		</p>
		<p class="tng-widget-admin tng-option-text">
			<label for="<?php echo $this->get_field_id( 'tree' ); ?>" class="tng-widget-label tng-tree"><?php _e( 'TNG Tree:' ); ?></label>
			<input id="<?php echo $this->get_field_id( 'tree' ); ?>" name="<?php echo $this->get_field_name( 'tree' ); ?>" type="text" value="<?php echo esc_attr( $tree ); ?>" class="tng-widget-input tng-tree" />
		</p>
		<?php
	}
}

function tng_get_random_profile_box( $base_url, $tree, $personID ) {
	global $personID, $tree, $profile2, $profilearr2, $namestr, $photostr, $yearstr;
	$profilearr2 = tng_get_random_profile_data( $tree, $personID );
	$personHREF2 = $base_url."getperson.php?personID=".$personID."&amp;tree=".$tree;
	$namestr = $profilearr2[0];
	$photostr = $profilearr2[1];
	$yearsstr = $profilearr2[2];

 	$profile2 = "<span class=\"tng-widget-content\">";
	$profile2 .= "<a href=\"".$personHREF2."\">\n";
 	$profile2 .= "<h5 class=\"tng-profile-name\">" . $namestr . "</h5>";
	$profile2 .= "</a>\n";
 	$profile2 .= "<span class=\"tng-profile-photo\" style=\"margin-left:2vw;\">" . $photostr . "</span>";
 	$profile2 .= "<h6 class=\"tng-profile-years\">" . $yearsstr . "</h6>";
 //	$profile2 .= "<p class=\"tng-widget-description\">" . $description . "</p>";
 	$profile2 .= "</span>";
 	return $profile2;
}

function tng_get_random_profile_data( $tree, $personID ) { 
	global $people_table, $tree, $personID, $namestr, $photostr, $yearsstr, $sex;
	$tng_folder = get_option('mbtng_path');
    include($tng_folder.'config.php');
	$link = mysqli_connect($database_host, $database_username, $database_password, $database_name) or die("Error: TNG is not communicating with your database. Please check your database settings and try again.");
	$query = "SELECT * FROM $people_table WHERE gedcom = '$tree' AND 'living' = 0 order by RAND() limit 1";
	$result = mysqli_query($link,$query) or die ("Unable to execute query: $query");
	$row=mysqli_fetch_array($result);
	
	if( !$num_rows = $result->num_rows ) {
		mysqli_free_result( $result );
		return NULL;
		exit;
	}
	else
		mysqli_free_result( $result );

    $row['allow_living'] = $rights['living'];
    $row['allow_private'] = $rights['private'];

	$namestr = $row['firstname']." ".$row['lastname'];
//	debugPrint($namestr);
	$photostr = getPhoto2();
//	debugPrint($photostr);
	$yearsstr = $row['birthdate']." &mdash; ".$row['deathdate'];
//	debugPrint($yearsstr);
	$sex = $row['sex'];
	$personID = $row['personID'];

	$arr2 = array( $namestr, $photostr, $yearsstr );	
	return $arr2;
}

function getPhoto2() {
	global $people_table,$medialinks_table, $media_table, $tree, $personID, $sex;
	$tng_folder = get_option('mbtng_path');
    include($tng_folder.'config.php');
	$base_url = trailingslashit($tngdomain);
	$link = mysqli_connect($database_host, $database_username, $database_password, $database_name) or die("Error: TNG is not communicating with your database. Please check your database settings and try again.");
	$query = "SELECT $people_table.sex, $media_table.mediaID, medialinkID, mediakey, alwayson, thumbpath, mediatypeID, usecollfolder, newwindow FROM ($people_table, $media_table, $medialinks_table)
		WHERE $medialinks_table.personID = '$personID' AND $medialinks_table.gedcom = '$tree' AND $media_table.mediaID = $medialinks_table.mediaID AND defphoto = '1'";
	$result = mysqli_query($link,$query) or die ("Unable to execute query: $query");
	$row = mysqli_fetch_array( $result );
	$showmedia_url = $tngdomain;
	$sex = $row['sex'];
	$media=$row['mediatypeID'].'/'.$row['thumbpath'];
	if ( !$num_rows = $result->num_rows && $sex=="M" ) $media = 'img/male.jpg';
	if ( !$num_rows = $result->num_rows && $sex=="F" ) $media = 'img/female.jpg';
	$photo2 = '<img src="'.$showmedia_url.'/'.$media.'" class="smallimg"/>';
	mysqli_free_result( $result );
	return $photo2;
}